From c2082f919535992b21488b532d91966f010c5e82 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Mon, 4 Apr 2022 16:53:16 -0700
Subject: [PATCH v69 10/28] pgstat: store statistics in shared memory.

Previously the statistics collector received statistics updates via UDP and
shared statistics data by writing them out to temporary files regularly. These
files can reach tens of megabytes and are created around once a second.

Now statistics are stored in shared memory. Statistics for variable-numbered
objects are stored in a dshash hashtable (backed by dynamic shared
memory). Fixed-numbered stats are stored in normal shared memory.

To avoid contention on the shared statistics data, each backend continues to
collect pending status updates and only flushes them out periodically.

To avoid contention on the shared hashtable, each backend has a backend-local
hashtable in front of the shared hashtable, containing references to the
shared hashtable entries. The shared hashtable only needs to be accessed when
no prior reference to the shared hashtable exists.

The stats collector is not needed anymore, remove it.

Subsequent commits contain tests and move pgstat.c to
src/backend/utils/activity.

TODO:
- verify all AFIXMEs

ATODO: bump PGSTAT_FILE_FORMAT_ID

Author: Kyotaro Horiguchi <horikyota.ntt@gmail.com>
Author: Andres Freund <andres@anarazel.de>
Author: Melanie Plageman <melanieplageman@gmail.com>
Reviewed-By: Andres Freund <andres@anarazel.de>
Reviewed-By: Thomas Munro <thomas.munro@gmail.com>
Reviewed-By: Justin Pryzby <pryzby@telsasoft.com>
Reviewed-By: "David G. Johnston" <david.g.johnston@gmail.com>
Reviewed-By: Tomas Vondra <tomas.vondra@2ndquadrant.com> (in a much earlier version)
Reviewed-By: Arthur Zakirov <a.zakirov@postgrespro.ru> (in a much earlier version)
Reviewed-By: Antonin Houska <ah@cybertec.at> (in a much earlier version)
Discussion: https://postgr.es/m/20220303021600.hs34ghqcw6zcokdh@alap3.anarazel.de
Discussion: https://postgr.es/m/20220308205351.2xcn6k4x5yivcxyd@alap3.anarazel.de
Discussion: https://postgr.es/m/20210319235115.y3wz7hpnnrshdyv6@alap3.anarazel.de
---
 src/include/miscadmin.h                       |    2 +-
 src/include/pgstat.h                          |  680 +--
 src/include/storage/lwlock.h                  |    3 +
 src/include/utils/pgstat_internal.h           |  613 ++-
 src/include/utils/rel.h                       |    1 +
 src/include/utils/timeout.h                   |    1 +
 src/include/utils/wait_event.h                |    1 -
 src/backend/access/transam/xlog.c             |   41 +-
 src/backend/commands/vacuum.c                 |    7 -
 src/backend/commands/vacuumparallel.c         |    2 +
 src/backend/lib/dshash.c                      |    4 +-
 src/backend/postmaster/autovacuum.c           |  197 +-
 src/backend/postmaster/checkpointer.c         |   20 +-
 src/backend/postmaster/interrupt.c            |    5 +-
 src/backend/postmaster/pgstat.c               | 4904 ++++-------------
 src/backend/postmaster/postmaster.c           |   91 +-
 src/backend/replication/logical/logical.c     |    1 -
 src/backend/replication/logical/tablesync.c   |    8 +-
 src/backend/replication/logical/worker.c      |    6 +
 src/backend/replication/slot.c                |   28 +-
 src/backend/storage/buffer/bufmgr.c           |    8 +-
 src/backend/storage/ipc/ipci.c                |    2 +
 src/backend/storage/lmgr/lwlock.c             |    8 +-
 src/backend/tcop/postgres.c                   |   29 +-
 src/backend/utils/activity/Makefile           |    1 +
 src/backend/utils/activity/pgstat_archiver.c  |   89 +-
 src/backend/utils/activity/pgstat_bgwriter.c  |   81 +-
 .../utils/activity/pgstat_checkpointer.c      |   93 +-
 src/backend/utils/activity/pgstat_database.c  |  327 +-
 src/backend/utils/activity/pgstat_function.c  |  165 +-
 src/backend/utils/activity/pgstat_relation.c  |  626 ++-
 src/backend/utils/activity/pgstat_replslot.c  |  189 +-
 src/backend/utils/activity/pgstat_shmem.c     | 1011 ++++
 src/backend/utils/activity/pgstat_slru.c      |  160 +-
 .../utils/activity/pgstat_subscription.c      |   86 +-
 src/backend/utils/activity/pgstat_wal.c       |  168 +-
 src/backend/utils/activity/pgstat_xact.c      |   39 +-
 src/backend/utils/activity/wait_event.c       |    3 -
 src/backend/utils/adt/pgstatfuncs.c           |   10 +-
 src/backend/utils/cache/relcache.c            |    5 +
 src/backend/utils/init/globals.c              |    1 +
 src/backend/utils/init/miscinit.c             |    3 -
 src/backend/utils/init/postinit.c             |   12 +
 src/backend/utils/misc/guc.c                  |   21 +
 src/backend/utils/misc/postgresql.conf.sample |    1 +
 contrib/test_decoding/expected/stats.out      |    1 +
 contrib/test_decoding/sql/stats.sql           |    1 +
 doc/src/sgml/monitoring.sgml                  |   19 +-
 src/test/modules/worker_spi/worker_spi.c      |    2 +-
 src/test/regress/expected/stats.out           |    8 +
 src/test/regress/sql/stats.sql                |   10 +
 src/tools/pgindent/typedefs.list              |   63 +-
 52 files changed, 4417 insertions(+), 5440 deletions(-)
 create mode 100644 src/backend/utils/activity/pgstat_shmem.c

diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index 0abc3ad5405..1d89b2759d2 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -94,6 +94,7 @@ extern PGDLLIMPORT volatile sig_atomic_t IdleInTransactionSessionTimeoutPending;
 extern PGDLLIMPORT volatile sig_atomic_t IdleSessionTimeoutPending;
 extern PGDLLIMPORT volatile sig_atomic_t ProcSignalBarrierPending;
 extern PGDLLIMPORT volatile sig_atomic_t LogMemoryContextPending;
+extern PGDLLIMPORT volatile sig_atomic_t IdleStatsUpdateTimeoutPending;
 
 extern PGDLLIMPORT volatile sig_atomic_t CheckClientConnectionPending;
 extern PGDLLIMPORT volatile sig_atomic_t ClientConnectionLost;
@@ -333,7 +334,6 @@ typedef enum BackendType
 	B_WAL_SENDER,
 	B_WAL_WRITER,
 	B_ARCHIVER,
-	B_STATS_COLLECTOR,
 	B_LOGGER,
 } BackendType;
 
